mod Mauxb logic: 'cl'

incl Mtex

incl Mtexbt

rem 
  \para \bf  Binary trees.  \end 

rem 
  \para \it  Arithmetization.  \end 

fun/0 E 'Tex_f0_bt_e'
  E = 0,0

fun/3 Nd 'Tex_f3_bt_nd'
  Nd(x,l,r) = 1,x,l,r

pred Bt 
  Bt(E)
  Bt Nd(x,l,r) <- N(x) & Bt(l) & Bt(r)

rem 
  \para \it  Membership in binary trees.  \end 

pred/2 Inbt 'Tex_p2_bt_in'
  Inbt(x,Nd(y,l,r)) <- x = y
  Inbt(x,Nd(y,l,r)) <- x != y & Inbt(x,l)
  Inbt(x,Nd(y,l,r)) <- x != y & ~Inbt(x,l) & Inbt(x,r)

thm Inbt_e
  ~Inbt(x,E)
proof  proved.

thm Inbt_nd
  Inbt(x,Nd(y,l,r)) <-> x = y \/ Inbt(x,l) \/ Inbt(x,r)
proof 
 cut x = y
  proved
  cut Inbt(x,l)
   proved
   proved...

rem 
  \para \bf  Binary search trees.  \end 

rem 
  \para \it  Tree comparision predicates.  \end 

pred/2 Lt 'Tex_p2_bt_lt'
  Lt(x,E)
  Lt(x,Nd(y,l,r)) <- x < y & Lt(x,l) & Lt(x,r)

pred/2 Gt 'Tex_p2_bt_gt'
  Gt(x,E)
  Gt(x,Nd(y,l,r)) <- x > y & Gt(x,l) & Gt(x,r)

rem 
  \para \it  Binary search trees.  \end 

pred Bst 
  Bst(E)
  Bst Nd(x,l,r) <- Gt(x,l) & Lt(x,r) & Bst(l) & Bst(r)

thm Bst_bt
  Bst(t) -> Bt(t)
proof 
 ind Bst; t @ 0; x,l,r
  proved
  proved..

